package com.tin.etbaf.annexure1;

import java.awt.Component;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.MouseEvent;
import java.util.EventObject;
import java.util.HashMap;
import java.util.List;

import javax.swing.*;
import javax.swing.table.TableCellEditor;
import javax.swing.text.JTextComponent;

import com.tin.etbaf.rpu.Chk_LengthOnly;
import com.tin.etbaf.rpu.GRPU;
import com.tin.etbaf.rpu.GrpuUtil;
import com.tin.etbaf.rpu.MyComboBoxRendererRemarks;
import com.tin.etbaf.rpu.MyComboBoxRendererRemarks;

// Referenced classes of package com.tin.etbaf.rpu:
//            Chk_LengthOnly, GRPU

public class GRPUTableCellEditorAnnex1Remarks_annex_new extends AbstractCellEditor
    implements TableCellEditor
{

	private JComboBox editor;
	private List<String> masterValues;
	private int row_count_annex1=0;
	int rowTable;
    int colTable;
    boolean exist_rows;
    String SecUnderPayMadeDed[];
    int selectedRow=0;
    int selYear_anne2=0;
    int next_year_anne2=0;
    String  formNumber;
    String quarter;
    //HashMap<String,ArrayList<Integer>> map=new HashMap<String,ArrayList<Integer>>(); 
    static HashMap<Integer,String[]> map=new HashMap<Integer,String[]>(); 
  
  //RPU 3.1 start //added parameter quarter
    public GRPUTableCellEditorAnnex1Remarks_annex_new(String SecUnderPayMadeDed[] ,int selectedRow ,int selYear_anne2,int next_year_anne2
    		,String formNumber , String quarter)
    {
    	 this.editor = new JComboBox();
         this.masterValues = masterValues;
         this.row_count_annex1=row_count_annex1;
         rowTable = 0;
         colTable = 0;
         this.exist_rows=exist_rows;
         this.selectedRow=selectedRow;
         //newly added by cholia
         this.selYear_anne2=selYear_anne2;
         this.next_year_anne2=next_year_anne2;
         this.formNumber=formNumber;
         this.quarter = quarter;
    
          //end  newly added by cholia
    }

    public Component getTableCellEditorComponent(JTable table, Object value, boolean isSelected, int rowIndex, int vColIndex)
    {
    	//DefaultComboBoxModel model = new DefaultComboBoxModel(masterValues.toArray(new String[masterValues.size()]));
    	//added by cholia
    	  
    	DefaultComboBoxModel model1=null;
    	/****************************************************/
    	//Added by Sadhana, FRD2.1
		//Change in section code 194J Fees for Professional or Technical Services for Form 26Q
    	String remark = null;
    	/****************************************************/
    	
    	if(!"--Select--".equals(table.getValueAt(table.getSelectedRow(),5).toString()))
    	     {
    			/****************************************************/
        		//Added by Sadhana, FRD2.1
    			//Change in section code 194J Fees for Professional or Technical Services for Form 26Q
    			//String remark=table.getValueAt(table.getSelectedRow(),5).toString();
    		  remark=table.getValueAt(table.getSelectedRow(),5).toString();
    		  /****************************************************/
    		  if (selYear_anne2 >= 2010 && next_year_anne2 >= 2011) {
  				if (formNumber.equals("24Q"))
  				{
  				 if(remark.equals("94P")){ //CR 80278 new section 94P
  						SecUnderPayMadeDed = (new String[] { "--Select--", "C" });
  					}
  					else
  						SecUnderPayMadeDed = (new String[] { "--Select--", "A",
  							"B", "C" });

  				}

  				if (formNumber.equals("26Q")) {
  																																																//Section Code changes for RPU 2.9 //RPU 3.2 start addition of new section 94K for form 26Q //RPU 3.3 start //RPU 3.4 start Addition of new section codes 
  					if (remark.equals("193") || remark.equals("194")|| remark.equals("94A") || remark.equals("4EE") || remark.equals("2AA")||remark.equals("LBB") || remark.equals("194IC")|| remark.equals("94N") || remark.equals("94K") || remark.equals("4JA") || remark.equals("4JB") || remark.equals("BA1") || remark.equals("BA2") || remark.equals("4NF")) {                                                                                                                                                                                                   
  						//Observation Defect fix :354 ---- Akansha
  						
  						if((selYear_anne2 == 2021 && (quarter.equals("Q2")||quarter.equals("Q3")||quarter.equals("Q4"))) || selYear_anne2 > 2021)
  							SecUnderPayMadeDed = (new String[] {"--Select--", "A",
   	  								"B - In case of 15G/15H", "C", "E","U", "Y", "Z" });
  						else if(selYear_anne2 >= 2020)	                                                             //RPU 3.4 start Addition of new remark E
 						{
  							
   							SecUnderPayMadeDed = (new String[] {"--Select--", "A",
   	  								"B - In case of 15G/15H", "C", "E", "Y", "Z" });
   						}
  						else if(selYear_anne2 >=2013)
  						SecUnderPayMadeDed = (new String[] {"--Select--", "A",
  								"B - In case of 15G/15H", "C", "Y", "Z" });
  						else 
  							SecUnderPayMadeDed = (new String[] { "--Select--", "A",
  	  								"B - In case of 15G/15H", "C", "Y"});
  					//End of Obvs fix
  						/*********************************************************/
  						if(remark.equals("2AA")){ 
  						SecUnderPayMadeDed = (new String[] {"--Select--", "A",
	  								"B - In case of 15G/15H", "C", "E", "Y", "Z" });
  						}
  						if(remark.equals("194")){ //CR 80278 new Remark P
  							if((selYear_anne2 == 2021 && (quarter.equals("Q2")||quarter.equals("Q3")||quarter.equals("Q4"))) || selYear_anne2 > 2021)
  							   SecUnderPayMadeDed = (new String[] {"--Select--", "A",
   	  								"B - In case of 15G/15H", "C", "E","P","U", "Y", "Z" });
  							else if(selYear_anne2 >= 2020)	                                                             //RPU 3.4 start Addition of new remark E
  						    SecUnderPayMadeDed = (new String[] {"--Select--", "A",
    	  								"B - In case of 15G/15H", "C", "E","P", "Y", "Z" });
  						 else
  							 SecUnderPayMadeDed = (new String[] {"--Select--", "A",
 	  								"B - In case of 15G/15H", "C", "E", "Y", "Z" });
  						}
  						if(remark.equals("94A")){
  							if((selYear_anne2 == 2021 && (quarter.equals("Q2")||quarter.equals("Q3")||quarter.equals("Q4"))) || selYear_anne2 > 2021)
  								SecUnderPayMadeDed = (new String[] { "--Select--", "A","B - In case of 15G/15H", "C", "D","E","Q","R", "U","Y", "Z" });
  	  						else if(selYear_anne2 >= 2021)	 //CR 80278 new remark Q
  								SecUnderPayMadeDed = (new String[] { "--Select--", "A","B - In case of 15G/15H", "C", "D","E","Q","R", "Y", "Z" });
  							else if(selYear_anne2 >= 2020)	//RPU 3.4 start Addition of new remark D for 194A
  								SecUnderPayMadeDed = (new String[] { "--Select--", "A","B - In case of 15G/15H", "C", "D","E", "R", "Y", "Z" });
  							else if(selYear_anne2 >= 2018)
  							SecUnderPayMadeDed = (new String[] { "--Select--", "A","B - In case of 15G/15H", "C", "R", "Y", "Z" });
  						}
  						/*********************************************************/
  					//Section Code changes for RPU 2.9
  					//RPU 3.1 start added remark N
  						if(remark.equals("94N"))
  						{
  							if(selYear_anne2 >= 2020)	
  							SecUnderPayMadeDed = (new String[] { "--Select--",  "C" , "E", "N"});
  							else if((selYear_anne2 == 2019 && (quarter.equals("Q2") ||quarter.equals("Q3")||quarter.equals("Q4"))) || selYear_anne2 > 2019)
  						{
    							SecUnderPayMadeDed = (new String[] { "--Select--",  "C" ,"N"});
  						}
  						
  						}
  					//RPU 3.2 start addition of new section 94K for form 26Q
  						if(remark.equals("94K") )
  						{
  							if((selYear_anne2 == 2021 && (quarter.equals("Q2")||quarter.equals("Q3")||quarter.equals("Q4"))) || selYear_anne2 > 2021)
  							SecUnderPayMadeDed = (new String[] { "--Select--", "B" , "C" , "E", "Y","U"});// RPU 3.7 CR 81169 New remark B
							else if(selYear_anne2 >= 2020)	 
  							SecUnderPayMadeDed = (new String[] { "--Select--", "B" , "C" , "E", "Y"});
  							else if(selYear_anne2 > 2019)
  							SecUnderPayMadeDed = (new String[] {"--Select--", "C" ,"Y"});
  						}
  						//rpu 3.3 start remark
  						if(remark.equals("4JA") || remark.equals("4JB"))
  						{
  							if((selYear_anne2 == 2021 && (quarter.equals("Q2")||quarter.equals("Q3")||quarter.equals("Q4"))) || selYear_anne2 > 2021)
  								SecUnderPayMadeDed = (new String[] { "--Select--", "A",
  	 	  								 "C", "E","Y","Z","S","U"});
  							else if(selYear_anne2 >= 2020)	
  								SecUnderPayMadeDed = (new String[] { "--Select--", "A",
 	  								 "C", "E","Y","Z","S"});
  						else if(selYear_anne2 > 2019 )
  						{
  							SecUnderPayMadeDed = (new String[] { "--Select--", "A",
  	  								 "C", "Y","Z","S"});
  						}
  						}
  					//RPU 3.4 start Addition of new section codes 
  						if(remark.equals("BA1") || remark.equals("BA2"))
  						{
  							if((selYear_anne2 == 2021 && (quarter.equals("Q2")||quarter.equals("Q3")||quarter.equals("Q4"))) || selYear_anne2 > 2021)
  								SecUnderPayMadeDed = (new String[] { "--Select--","C", "E","O","U","Z"});
  							else if(selYear_anne2 >= 2020)	
  								SecUnderPayMadeDed = (new String[] { "--Select--","C", "E","O","Z"});
  						}
  						if(remark.equals("4NF"))
  						{
  							 if((selYear_anne2 == 2020 && (quarter.equals("Q2") ||quarter.equals("Q3")||quarter.equals("Q4"))) || selYear_anne2 > 2020)	  
  			                 SecUnderPayMadeDed = (new String[] { "--Select--", "C","E","M"});
  						}
  					}
  					//newly added for FRD1.6 by Akansha
  					else if(remark.equals("LBC"))
  						if(selYear_anne2 >= 2020)	
  						SecUnderPayMadeDed = (new String[] { "--Select--", "A", "C" , "E", "Y", "Z" });
  						else if(selYear_anne2 >=2016)
  							SecUnderPayMadeDed = (new String[] { "--Select--", "A","C", "Y", "Z" });
  						  
  					//********************************************************************
  					 if (remark.equals("94B") || remark.equals("4BB")
  							|| remark.equals("94G")
  							|| remark.equals("94H") || remark.equals("94I")
  							|| remark.equals("94L")
  							) {
  						if((selYear_anne2 == 2021 && (quarter.equals("Q2")||quarter.equals("Q3")||quarter.equals("Q4"))) || selYear_anne2 > 2021)
  						{	if((remark.equals("94B") || remark.equals("4BB")))
  							 SecUnderPayMadeDed = (new String[] { "--Select--", "A","C","E","Y", "Z" });
  						else
  							 SecUnderPayMadeDed = (new String[] { "--Select--", "A","C","E", "U","Y", "Z" });
  						}
  						else if(selYear_anne2 >= 2020)
  						{ SecUnderPayMadeDed = (new String[] { "--Select--", "A","C","E", "Y", "Z" });  							
   						}
  						else if(selYear_anne2>=2013){
  								SecUnderPayMadeDed = (new String[] { "--Select--", "A","C", "Y", "Z" });
  						}
  						 
  						else{
  							SecUnderPayMadeDed = (new String[] { "--Select--", "A","C", "Y"});
  						}
  				
  					}
  					/******************************************************************/
  					 //Added by Sadhana on 05/04/2017 FRDS2.0
  					if (remark.equals("94D")) {
  						if((selYear_anne2 == 2021 && (quarter.equals("Q2")||quarter.equals("Q3")||quarter.equals("Q4"))) || selYear_anne2 > 2021)
  						{
  							SecUnderPayMadeDed = (new String[] { "--Select--", "A", "B", "C","E", "U","Y", "Z" });  							
  						}
	   						
  						
  						else if(selYear_anne2 >= 2013 && selYear_anne2 < 2017){
  								SecUnderPayMadeDed = (new String[] { "--Select--", "A","C", "Y", "Z" });
  						}
  						else if(selYear_anne2 >= 2017){
  							SecUnderPayMadeDed = (new String[] { "--Select--", "A", "B", "C", "Y", "Z" });
  						}else{
  							SecUnderPayMadeDed = (new String[] { "--Select--", "A","C", "Y"});
  						}
  					}
  					/******************************************************************/
  					
  					//newly added for FRD1.6 by Akansha
  					if(remark.equals("4IA")
  							|| remark.equals("4IB"))
  					{
  						if((selYear_anne2 == 2021 && (quarter.equals("Q2")||quarter.equals("Q3")||quarter.equals("Q4"))) || selYear_anne2 > 2021)
  					{ 
  						SecUnderPayMadeDed = (new String[] { "--Select--", "A","B - In case of 15G/15H",
							"C","E","U", "Y", "Z" });  							
					}
  						
  					else if(selYear_anne2 >= 2020)  
    						{ SecUnderPayMadeDed = (new String[] { "--Select--", "A","B - In case of 15G/15H",
    								"C","E", "Y", "Z" });  							
    						}
  						 else if(selYear_anne2>=2013)
								SecUnderPayMadeDed = (new String[] { "--Select--", "A","B - In case of 15G/15H",
								"C", "Y", "Z" });
  					}
  					
  					if(remark.equals("94O")) //RPU 3.5 start Addition of new section codes from 26Q
  					{
  						if((selYear_anne2 == 2021 && (quarter.equals("Q2")||quarter.equals("Q3")||quarter.equals("Q4"))) || selYear_anne2 > 2021)
  						{ 
  							SecUnderPayMadeDed = (new String[] { "--Select--","A", "C","E" ,"Y" ,"U" });  							
						}
  					else if((selYear_anne2 == 2020 && (quarter.equals("Q3")||quarter.equals("Q4"))) || selYear_anne2 > 2020) 
    						{ SecUnderPayMadeDed = (new String[] { "--Select--","A", "C","E" ,"Y" });  							
    						}
  					}
  					if(remark.equals("94Q")) //RPU 3.7 CR 81169 start Addition of new Remark for form 26Q
  					{
  						 SecUnderPayMadeDed = (new String[] { "--Select--","C", "S" ,"U"});  							
    						
  					}
  					
  					//***********************************************************************  					

  					else if (remark.equals("94C")) {
  						if((selYear_anne2 == 2021 && (quarter.equals("Q2")||quarter.equals("Q3")||quarter.equals("Q4"))) || selYear_anne2 > 2021)
  							SecUnderPayMadeDed = (new String[] { "--Select--", "A",
	  								"C", "E" ,"T", "U","Y", "Z" });  
  						else if(selYear_anne2 >= 2020)	  
						 SecUnderPayMadeDed = (new String[] { "--Select--", "A",
	  								"C", "E" ,"T", "Y", "Z" });  							
  						else if(selYear_anne2>=2013)
  						SecUnderPayMadeDed = (new String[] { "--Select--", "A",
  								"C", "T", "Y", "Z" });
  						else if((selYear_anne2 == 2021 && (quarter.equals("Q2")||quarter.equals("Q3")||quarter.equals("Q4"))) || selYear_anne2 > 2021)
  							SecUnderPayMadeDed = (new String[] { "--Select--", "A",
  	  								"C", "T", "Y","U", "Z" });
  						else
  							SecUnderPayMadeDed = (new String[] { "--Select--", "A",
  	  								"C", "T", "Y"});
  						//End of Obvs fix
  					}

  					else if (remark.equals("94J")) {

  						//newly added by choia on 9 march

  					    if(selYear_anne2 >= 2012 && selYear_anne2 <2013)
  					    {

  							SecUnderPayMadeDed = (new String[] { "--Select--", "A",
  									"C", "Y", "S",
  									});
  					    }
  					    else if(selYear_anne2 >= 2013 && selYear_anne2 < 2017)
  					    {
  					    	SecUnderPayMadeDed = (new String[] { "--Select--", "A",
  									"C", "Y", "S","Z"
  									});
  					    }					 
  					 
  					   else if(selYear_anne2 >= 2017){
 					    	SecUnderPayMadeDed = (new String[] { "--Select--", "A", "B",
 									"C", "Y", "S","Z"
 									});
 					    }
  					 else if(selYear_anne2 >= 2020) //RPU 3.4 start Addition of new remark
 					  {
 						SecUnderPayMadeDed = (new String[] { "--Select--", "A", "B",
									"C", "E","Y", "S","Z"
									});
 					  }
  					   else  if((selYear_anne2 == 2021 && (quarter.equals("Q2")||quarter.equals("Q3")||quarter.equals("Q4"))) || selYear_anne2 > 2021)
  					  {//RPU 3.7 CR 81169 Remark U
  	  						SecUnderPayMadeDed = (new String[] { "--Select--", "A", "B",
  										"C", "E","Y", "S","U","Z"
  	 									});
  	  					  }	
  					    else
  					    	SecUnderPayMadeDed = (new String[] { "--Select--", "A",
  									"C", "Y"  });
  					
  					//end 	//newly added by choia on 9 march

  					}

  					else if (remark.equals("94F")
  							|| remark.equals("4BA") // new development for FRD1.3 by Akansha
  							|| remark.equals("4DA")) {
  						//Observation Defect fix :354 ---- Akansha
  						if(selYear_anne2>=2013){
  							if(remark.equals("4DA")) 
  							{	//RPU 3.7 CR 81169 Remark U
  								if((selYear_anne2 == 2021 && (quarter.equals("Q2")||quarter.equals("Q3")||quarter.equals("Q4"))) || selYear_anne2 > 2021)
  							{
  								SecUnderPayMadeDed = (new String[] { "--Select--", "A","B - In case of 15G/15H",
		  								"C", "E","U","Z" });
  								
  							}
  								else if(selYear_anne2 >= 2020)
  								{
  									SecUnderPayMadeDed = (new String[] { "--Select--", "A","B - In case of 15G/15H",
  			  								"C", "E","Z" });
  								}
  							else
  								SecUnderPayMadeDed = (new String[] { "--Select--", "A","B - In case of 15G/15H",
  								"C", "Z" });
  							}
  						//RPU 3.4 start Addition of new remark 
  						//RPU 3.7 CR 81169 Remark U
  							else if((selYear_anne2 == 2021 && (quarter.equals("Q2")||quarter.equals("Q3")||quarter.equals("Q4"))) || selYear_anne2 > 2021)
  							{
  								SecUnderPayMadeDed = (new String[] { "--Select--", "A",
  		  								"C", "E", "U","Z" });
  								}
  							else if(selYear_anne2 >= 2020)
  								{
  								SecUnderPayMadeDed = (new String[] { "--Select--", "A",
  		  								"C", "E", "Z" });
  								}
  							else
  								SecUnderPayMadeDed = (new String[] { "--Select--", "A",
  		  								"C", "Z" });
  							
  							
  						}else{
  							if(remark.equals("4DA")) //new development for FRD1.5 by Akansha
  								SecUnderPayMadeDed = (new String[] { "--Select--", "A","B - In case of 15G/15H",
  	  								"C"});
  							else
  								SecUnderPayMadeDed = (new String[] { "--Select--", "A",
	  								"C"});
  						}
   					}
  				}

  				// yahan pe added for form 27Q
  				if (formNumber.equals("27Q"))
				{//RPU 3.7 CR 81169 new remark 'J'
					if (remark.equals("94E") || remark.equals("96A") || remark.equals("96B") || remark.equals("96C")
							|| remark.equals("4LB") || remark.equals("4LC") || remark.equals("4LD")
							|| remark.equals("4BA") || remark.equals("94N")) // RPU 3.0 start
					{
						if (!(remark.equals("94N"))
								&& (selYear_anne2 == 2021
										&& (quarter.equals("Q2") || quarter.equals("Q3") || quarter.equals("Q4")))
								|| selYear_anne2 > 2021) {
							SecUnderPayMadeDed = (new String[] { "--Select--", "A", "B", "C", "G", "J" });
						} else if (selYear_anne2 >= 2020) { // RPU 3.4 start Addition of new remark
							SecUnderPayMadeDed = (new String[] { "--Select--", "A", "B", "C", "G" });
						} else
							SecUnderPayMadeDed = (new String[] { "--Select--", "A", "B", "C" });
					} else {
						if ((selYear_anne2 == 2021
								&& (quarter.equals("Q2") || quarter.equals("Q3") || quarter.equals("Q4")))
								|| selYear_anne2 > 2021)
							SecUnderPayMadeDed = (new String[] { "--Select--", "A", "B", "C", "G", "J","S" });
						else if (selYear_anne2 >= 2020) { // RPU 3.4 start Addition of new remark
							SecUnderPayMadeDed = (new String[] { "--Select--", "A", "B", "C", "G", "S" });
						} else if (selYear_anne2 >= 2012) {
							SecUnderPayMadeDed = (new String[] { "--Select--", "A", "B", "C", "S" });
						} else
							SecUnderPayMadeDed = (new String[] { "--Select--", "A", "B", "C" });

					}
					if (remark.equals("6DA"))// CR 80278 new section code 196DP
					{
						SecUnderPayMadeDed = (new String[] { "--Select--", "C", "G", "H", "I" ,"J"});
					}
					if (remark.equals("96D")) // CR 80278 New remarks for section 96D
					{
						if((selYear_anne2 == 2021 && (quarter.equals("Q2")||quarter.equals("Q3")||quarter.equals("Q4"))) || selYear_anne2 > 2021)
							SecUnderPayMadeDed = (new String[] { "--Select--", "C", "G", "I","J" });
						else 	if (selYear_anne2 >= 2021)
							SecUnderPayMadeDed = (new String[] { "--Select--", "C", "G", "I" });
						else if (selYear_anne2 == 2020)
							SecUnderPayMadeDed = (new String[] { "--Select--", "A", "B", "C", "G" });
						else
							SecUnderPayMadeDed = (new String[] { "--Select--", "A", "B", "C" });

					}
					if (remark.equals("2AA") || remark.equals("LBB")) {
						if (remark.equals("LBB")
								&& (selYear_anne2 == 2021
										&& (quarter.equals("Q2") || quarter.equals("Q3") || quarter.equals("Q4")))
								|| selYear_anne2 > 2021)
							SecUnderPayMadeDed = (new String[] { "--Select--", "A", "B", "C", "G", "J", "S" });
						else if (selYear_anne2 >= 2020)
							SecUnderPayMadeDed = (new String[] { "--Select--", "A", "B", "C", "G", "S" });
						else
							SecUnderPayMadeDed = (new String[] { "--Select--", "A", "B", "C", "S" });
					}
					// added newly for FRD1.6 by akansha
					if ("LBC".equals(remark))
						if (selYear_anne2 >= 2020)
							SecUnderPayMadeDed = (new String[] { "--Select--", "A", "C", "G", "S" });
						else if (selYear_anne2 >= 2016)
							SecUnderPayMadeDed = (new String[] { "--Select--", "A", "C", "S" });
					// ************************************************************
					// RPU 3.1 start added remark N
					if (selYear_anne2 == 2019 && remark.equals("94N")) {
						if ((quarter.equals("Q2") || quarter.equals("Q3") || quarter.equals("Q4")))
							SecUnderPayMadeDed = (new String[] { "--Select--", "A", "B", "C", "N" });
					} else if (selYear_anne2 > 2019 && remark.equals("94N"))
						SecUnderPayMadeDed = (new String[] { "--Select--", "A", "B", "C", "G", "N" });
					// RPU 3.4 start Addition of new remark
					if ((remark.equals("BA1") || remark.equals("BA2"))) {
						if ((selYear_anne2 == 2021
								&& (quarter.equals("Q2") || quarter.equals("Q3") || quarter.equals("Q4")))
								|| selYear_anne2 > 2021)
							SecUnderPayMadeDed = (new String[] { "--Select--", "C", "G", "J", "O" });
						else if (selYear_anne2 >= 2020)
							SecUnderPayMadeDed = (new String[] { "--Select--", "C", "G", "O" });
					}
					if (remark.equals("BA3") & selYear_anne2 >= 2020) {
						if ((selYear_anne2 == 2021
								&& (quarter.equals("Q2") || quarter.equals("Q3") || quarter.equals("Q4")))
								|| selYear_anne2 > 2021)
							SecUnderPayMadeDed = (new String[] { "--Select--", "C", "G", "J" });
						else if (selYear_anne2 >= 2020)
							SecUnderPayMadeDed = (new String[] { "--Select--", "C", "G" });
					}

					if (remark.equals("4NF") && ((selYear_anne2 == 2020
							&& (quarter.equals("Q2") || quarter.equals("Q3") || quarter.equals("Q4")))
							|| selYear_anne2 > 2020))
						SecUnderPayMadeDed = (new String[] { "--Select--", "C", "G", "M" });
				}
  					

  				if (formNumber.equals("27EQ")) {
  					//RPU 3.7 CR 81169 New remark "I" for all section codes
  					if((selYear_anne2 == 2021 && (quarter.equals("Q2")||quarter.equals("Q3")||quarter.equals("Q4"))) || selYear_anne2 > 2021)
  					{
  						if("O".equals(remark)||"P".equals(remark))
  					{
  						SecUnderPayMadeDed = (new String[] { "--Select--", "C","E", "F","I"});
  					}
  						else if("Q".equals(remark))
  					{ 
  							SecUnderPayMadeDed = (new String[] { "--Select--", "C","D","E","F","I"});
  					}
  						else if("R".equals(remark))
  					{ 
  							SecUnderPayMadeDed = (new String[] { "--Select--", "C","G","H","I"});
  					}
  						else 
  							SecUnderPayMadeDed = (new String[] { "--Select--","A", "B", "C","I"});
  					}
  					 //RPU 3.5 start Addition of new remark 
  					else if((selYear_anne2 == 2020 && (quarter.equals("Q3")||quarter.equals("Q4"))) || selYear_anne2 > 2020)
  					{
  						if("O".equals(remark)||"P".equals(remark))
  					{
  						SecUnderPayMadeDed = (new String[] { "--Select--", "C","E", "F"});
  					}
  						else if("Q".equals(remark))
  					{ 
  							SecUnderPayMadeDed = (new String[] { "--Select--", "C","D","E","F"});
  					}
  						else if("R".equals(remark))
  					{ 
  							SecUnderPayMadeDed = (new String[] { "--Select--", "C","G","H"});
  					}
  						else 
  							SecUnderPayMadeDed = (new String[] { "--Select--","A", "B", "C"});
  					}
  					
  					else if(selYear_anne2 >= 2017){
						SecUnderPayMadeDed = (new String[] { "--Select--","A", "B", "C"});
					}
					else{
						SecUnderPayMadeDed = (new String[] { "--Select--","A", "B"});
					}
						
  					if("L".equals(remark)||"M".equals(remark)||"N".equals(remark)){
  						if((selYear_anne2 == 2021 && (quarter.equals("Q2")||quarter.equals("Q3")||quarter.equals("Q4"))) || selYear_anne2 > 2021)
  							SecUnderPayMadeDed = (new String[] { "--Select--", "A","C","I"});
  						else if(selYear_anne2>=2016 && selYear_anne2 < 2017){
  							SecUnderPayMadeDed = (new String[] { "--Select--", "A"});
  						}else{
  							SecUnderPayMadeDed = (new String[] { "--Select--", "A", "C"});
  						}
  						/**************************************************************/
  					}
  					//*******************************************************
  				}

  			}
    		  
    		  model1=new DefaultComboBoxModel(SecUnderPayMadeDed);
    	     
    	     }
    	else
    		model1=new DefaultComboBoxModel((new String[] { "--Select--"}));
    	
    	
    	
    	editor.setModel(model1);
        editor.setSelectedItem(value);
        editor.setRenderer(new MyComboBoxRendererRemarks(SecUnderPayMadeDed,formNumber,editor, remark));
      
        return editor;
        	
    }

    public Object getCellEditorValue()
    {
       
    	return editor.getSelectedItem();
    }

    public boolean isCellEditable(EventObject evt)
    {
        if(evt instanceof MouseEvent)
        {
            int clickCount = 2;
            return ((MouseEvent)evt).getClickCount() >= clickCount;
        } else
        {
            return true;
        }
    }
}
